+++
title = "Webserver unter Ruby"
date = "2009-06-11T09:12:00+00:00"
author = "Gibheer"
draft = false
+++

Wenn man unter Ruby eine Webserveranbindung braucht, so kann man das
&uuml;ber einzelne Plugins wie fcgi, thin oder &auml;hnliches regeln.
Allerdings geht dann die F&auml;higkeit verloren, die Applikation
&uuml;ber einen beliebigen Webserver laufen zu lassen, zum Beispiel in
der Produktionsumgebung &uuml;ber lighttpd mit fcgi und zum testen
&uuml;ber WEBrick.

Rack bietet da eine tolle M&ouml;glichkeit, die Applikation in einer
Webumgebung laufen zu lassen, ohne das man selbst an alle Server denken
muss, weil eine Portierung so einfach ist.

F&uuml;r Rack gibt es, bis auf die Dokumentation der einzelnen
Funktionen, keine andere Quelle, die anschaulich erkl&auml;rt, wie man
Rack benutzen kann.

Es gibt eine Serie von Screencasts, die genau diese L&uuml;cke
f&uuml;llen. Remi hat auf seiner Seite anfang des Jahres den Screencast
[Rack Basics](http://remi.org/2009/02/19/rack-basics.html) erstellt, der
auf sehr gute Art und Weise erkl&auml;rt, wie man mit Rack umgehen kann.
In Teil 2 und 3 besch&auml;ftigt er sich auch noch mit Middleware, wie
zum Beispiel einen File Reloader, die man hinzuschalten kann.
