+++
title = "publisher contains only packages from other publisher"
date = "2009-11-18T07:14:00+00:00"
author = "Gibheer"
draft = false
+++

Nach dem Update von opensolaris auf snv\_127, bekam ich immer wieder
Meldungen, dass mein publisher dev nur Pakete des publishers
opensolaris.org enthaelt.

Die gesamte Meldung sieht wie folgt aus

<source:sh>\
Refreshing catalog 1/1 devpkg publisher

The catalog retrieved for publisher ‘dev’ only contains package data for
these publisher(s): opensolaris.org. To resolve this issue, update this
publisher to use the correct repository origin, or add one of the listed
publishers using this publisher’s repository origin.

To correct the repository origin, execute the following command as a
privileged user:

pkg set-publisher ~~O <url> dev
\
To add a new publisher using this publisher’s repository origin, execute
the following command as a privileged user:
\
pkg set-publisher~~O http://pkg.opensolaris.org/dev/ <publisher>

After the new publisher has been added, this one should be removed by
executing the following command as a privileged user:

pkg unset-publisher dev\
</source>

Der Meldung nach zu Urteilen, sollte es also reichen, wenn ich meinen
dev-publisher neu anlege, doch weit gefehlt. Es handelt sich dabei um
eine Aenderung am Paketsystem ([Erklaerung
hier](http://blogs.sun.com/srw/entry/do_you_want_to_go)) welche die
Struktur des Paketespeichers zusammenlegt und damit den alten
opensolaris-Stand ueberfluessig macht.

Das haette man vielleicht mal in die Meldung dazu schreiben koennen.
Denn Aufgrund dieser Aenderung konnte ich nicht einmal mehr Pakete
installieren, weil mein default-publisher dev war und keine Updates mehr
bekam.

Die Loesung des Problems bestand dann darin, einen der beiden publisher
zu loeschen. Ich hab dev geloescht und opensolaris.org auf dev
umgeleitet.
